//register events
registerInputEvent("fxDTSBrick","onBrickEnterWater","Self fxDTSBrick" TAB
                                                 "Player Player" TAB
                                                 "Client GameConnection" TAB
                                                 "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onBrickExitWater","Self fxDTSBrick" TAB
                                                 "Player Player" TAB
                                                 "Client GameConnection" TAB
                                                 "MiniGame MiniGame");												 		 			 
$onEnterWaterIndex = inputEvent_GetInputEventIdx("onBrickEnterWater");
if(!isObject(onEnterWaterSet))
	new SimSet(onEnterWaterSet);
$onExitWaterIndex = inputEvent_GetInputEventIdx("onBrickExitWater");
if(!isObject(onExitWaterSet))
	new SimSet(onExitWaterSet);
	
package WaterEvents
{
	//Modify water level changing function
	function serverCmdEnvGui_SetVar(%client,%var,%val)
	{
		Parent::serverCmdEnvGui_SetVar(%client,%var,%val);
		
		//If we raise or lower the already existing water, or changing between simple and advanced mode
		if((%var $= "WaterHeight" && isObject(WaterPlane)) || %var $= "SimpleMode")
		{
			%height = getWord(WaterPlane.getPosition(),2) + 0.5;
			
			//Check for bricks entering water
			%count = onEnterWaterSet.getCount();
			for(%i=0;%i<%count;%i++)
			{
				
				%brick = onEnterWaterSet.getObject(%i);
				%brickZPos = getWord(%brick.getWorldBox(),2);
				if(!%brick.isInWater && %height >= %brickZPos)
					doWaterLevelEvent(%brick,1);
			}
			
			//Check for bricks exiting water
			%count = onExitWaterSet.getCount();
			for(%i=0;%i<%count;%i++)
			{
			
				%brick = onExitWaterSet.getObject(%i);
				%brickZPos = getWord(%brick.getWorldBox(),2);
				if(%brick.isInWater && %height < %brickZPos)
					doWaterLevelEvent(%brick,0);
			}
		}
		
		//Creating or deleting water
		if(%var $= "WaterIdx")
		{
			if(%val)//Creating Water
			{
				%height = getWord(WaterPlane.getPosition(),2) + 0.5;
				%count = onEnterWaterSet.getCount();
				for(%i=0;%i<%count;%i++)
				{
					
					%brick = onEnterWaterSet.getObject(%i);
					%brickZPos = getWord(%brick.getWorldBox(),2);
					if(!%brick.isInWater && %height >= %brickZPos)
						doWaterLevelEvent(%brick,1);
				}
			}
			else //Deleting water
			{
				%count = onExitWaterSet.getCount();
				for(%i=0;%i<%count;%i++)
				{
					
					%brick = onExitWaterSet.getObject(%i);
					if(%brick.isInWater)
						doWaterLevelEvent(%brick,0);
				}
			}
		}
	}

	//Listen for when a client adds an event, so we can and the brick to a group
	function serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4)
	{
		if(%input == $onEnterWaterIndex)
		{
			onEnterWaterSet.add(%client.wrenchBrick);
				
			//Check if the brick event already under water, then fire the event if it was
			if(isObject(WaterPlane))
			{	
				%height = getWord(WaterPlane.getPosition(),2) + 0.5;
				%brickZPos = getWord(%client.wrenchBrick.getWorldBox(),2);
				if(%height >= %brickZPos)
						schedule(50,0,doWaterLevelEvent,%client.wrenchBrick,1);
			}
		}
		if(%input == $onExitWaterIndex)
			onExitWaterSet.add(%client.wrenchBrick);
		return Parent::serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4);
	}
	//Remove the brick from group when we remove the event
	function serverCmdClearEvents(%client)
	{
		if(onEnterWaterSet.isMember(%client.wrenchBrick))
			onEnterWaterSet.remove(%client.wrenchBrick);
		if(onExitWaterSet.isMember(%client.wrenchBrick))
			onExitWaterSet.remove(%client.wrenchBrick);
		Parent::serverCmdClearEvents(%client);
	}
	
	//Duplicator Support
	function fxDtsBrick::onPlant(%this)
	{
		%r = Parent::onPlant(%this);
		%this.schedule(50,checkForWaterlevelEvents);
		return %r;
	}
};
ActivatePackage(WaterEvents);

function doWaterLevelEvent(%brick,%inWater)
{
	$InputTarget_["Self"]   = %brick;
	$InputTarget_["Player"] = %brick.getGroup().client.player;
	$InputTarget_["Client"] = %brick.getGroup().client;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick.getGroup().client.player);
	}
	else
	{
		if(getMiniGameFromObject(%brick) == getMiniGameFromObject(%brick.getGroup().client.player))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
		else
			$InputTarget_["MiniGame"] = 0;
	}
	if(%inWater)
	{
		%brick.isInWater = 1; //Set a variable to check later, so we only process the event once, instead of continously processing every time the water level is changed
		%brick.processInputEvent("onBrickEnterWater", %brick.getGroup().client);
	}
	else
	{
		%brick.isInWater = 0;
		%brick.processInputEvent("onBrickExitWater", %brick.getGroup().client);
	}
}

function fxDtsBrick::checkForWaterlevelEvents(%this)
{
	for(%i=0;%i<%this.numEvents;%i++)
	{
		if(%this.eventInputIdx[%i] == $onEnterWaterIndex)
			onEnterWaterSet.add(%this);
		if(%this.eventInputIdx[%i] == $onExitWaterIndex)
			onExitWaterSet.add(%this);
	}
}